include "basics/pts.ma".
include "connectives.ma".
include "leibniz.ma".
include "logic.ma".
axiom nat : Type[0].
axiom O : nat.
axiom S : nat -> nat.
axiom match_nat_type : \forall return_ : Type[0] . return_ -> (nat -> return_) -> nat -> return_.
axiom axiom_match_nat_type_S : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). \forall (n:nat). (equal) (return_type) ((match_nat_type) (return_type) case_O case_S ((S)  n)) (case_S n).
definition eq_match_nat_type_S : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). \forall (n:nat). (leibniz) (return_type) ((match_nat_type) (return_type) case_O case_S ((S)  n)) (case_S n) := \lambda return_type : Type[0]. \lambda case_O : return_type. \lambda case_S : nat -> return_type. \lambda n : nat. ((((equal_leibniz) (return_type)) ((match_nat_type) (return_type) case_O case_S ((S)  n))) (case_S n)) (((((axiom_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
definition sym_eq_match_nat_type_S : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). \forall (n:nat). (leibniz) (return_type) (case_S n) ((match_nat_type) (return_type) case_O case_S ((S)  n)) := \lambda return_type : Type[0]. \lambda case_O : return_type. \lambda case_S : nat -> return_type. \lambda n : nat. ((((sym_leibniz) (return_type)) ((match_nat_type) (return_type) case_O case_S ((S)  n))) (case_S n)) (((((eq_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
definition pred : nat -> nat := \lambda n : nat. (match_nat_type) (nat) (O)  (\lambda p : nat. p) n.
axiom le : nat -> nat -> Prop.
axiom match_le_prop : \forall (n:nat). \forall (return_:nat -> Prop). (return_ n) -> (\forall (m:nat). return_ ((S)  m)) -> \forall (m:nat). ((le)  n m) -> return_ m.
definition lt : nat -> nat -> Prop := \lambda n : nat. \lambda m : nat. (le)  ((S)  n) m.
definition pred_Sn : \forall (n:nat). (eq) (nat) n ((pred)  ((S)  n)) := \lambda n : nat. ((((((sym_eq_match_nat_type_S) (nat)) ((O) )) (\lambda p : nat. p)) (n)) (\lambda y : nat. (eq) (nat) n y)) (((refl) (nat)) (n)).
definition S_pred : \forall (n:nat). ((lt)  (O)  n) -> (eq) (nat) ((S)  ((pred)  n)) n := \lambda n : nat. \lambda posn : (lt)  (O)  n. (((((((match_le_prop) ((S)  (O) )) (\lambda j__ : nat. (eq) (nat) ((S)  ((pred)  j__)) j__)) (((((((rewrite_l) (nat)) ((O) )) (\lambda j__ : nat. (eq) (nat) ((S)  j__) ((S)  (O) ))) (((refl) (nat)) ((S)  (O) ))) ((pred)  ((S)  (O) ))) ((pred_Sn) ((O) )))) (\lambda m : nat. ((((((rewrite_l) (nat)) (m)) (\lambda j__ : nat. (eq) (nat) ((S)  j__) ((S)  m))) (((refl) (nat)) ((S)  m))) ((pred)  ((S)  m))) ((pred_Sn) (m)))) (n)) (posn)).
